function love.load()
	v1 = {x = 200, y = 200}
	v2 = {x = 400, y = 250}
	v3 = {x = 250, y = 500}
	inside = false
end

local function isPointInTriangle(point, v1, v2, v3)
	local function calculateTriangleArea(v1, v2, v3)
		return 0.5 * math.abs((v1.x - v3.x) * (v2.y - v1.y) - (v1.x - v2.x) * (v3.y - v1.y))
	end
	local totalArea = calculateTriangleArea(v1, v2, v3)
	local area1 = calculateTriangleArea(point, v2, v3)
	local area2 = calculateTriangleArea(v1, point, v3)
	local area3 = calculateTriangleArea(v1, v2, point)
	return math.abs(totalArea - (area1 + area2 + area3)) < 1e-6
end

function love.draw()
	if inside then
		love.graphics.setColor(0,1,1)
	else
		love.graphics.setColor(1,0,0)
	end
	love.graphics.line(v1.x, v1.y, v2.x, v2.y)
	love.graphics.line(v2.x, v2.y, v3.x, v3.y)
	love.graphics.line(v3.x, v3.y, v1.x, v1.y)
	love.graphics.circle ('line', v3.x, v3.y, 5)
end

function love.mousemoved(x, y)
	inside = isPointInTriangle({x=x, y=y}, v1, v2, v3)
end

function love.mousepressed(x, y)
	v2, v3 = v3, v2
	inside = isPointInTriangle({x=x, y=y}, v1, v2, v3)
end
